var MailSetup = {};

MailSetup.Init = 
function()
{	

}

MailSetup.End = 
function()
{	

}

MailSetup.loadData =
function()
{
	theApp.Content.body.mask(Geo.Text.LoadMask.loading, 'x-mask-loading');
			
	SrvSetup.MailServiceForm.getForm().load({
	
		url:'ServerSetupData.php',
		params: {requestType: 'GetMailServiceSetupData'},
		success: function()
		{
			theApp.Content.body.unmask();
			
			var obj;
			
			obj = SrvSetup.MailServiceForm.getForm().findField('mail_username');
			if( obj && obj.getValue() == '' )
				obj.setValue('admin');
			
			obj = SrvSetup.MailServiceForm.getForm().findField('mail_password');
			if( obj && obj.getValue() == '' )
				obj.setValue('admin');		
			
		},
		failure: function(form, action){
			theApp.Content.body.unmask();
			SubmitFail(action,true,true);
		}
	});	
}

MailSetup.saveData =
function()
{
	theApp.Content.body.mask(Geo.Text.LoadMask.sending, 'x-mask-loading');			
					
	SrvSetup.MailServiceForm.getForm().submit(
	{
		url: 'ServerSetupData.php',
		method: 'POST',
		params: {requestType: 'SetMailServiceSetupData'},
		success: function(form, action) {
			
			theApp.Content.body.unmask();
			CommonFunc.showMsgBox(Geo.Text.Common.message,Geo.Text.Common.success);							
		},
		failure: function(form, action) {
			
			theApp.Content.body.unmask();
			SubmitFail(action,true,true);
		}
	});	
}

MailSetup.testMail =
function()
{
	var ip = SrvSetup.MailServiceForm.getForm().findField('mail_smtp').getValue();
	var mailFrom = SrvSetup.MailServiceForm.getForm().findField('mail_from').getValue();
	var mailTo = SrvSetup.MailServiceForm.getForm().findField('mail_to').getValue();
	var subject = SrvSetup.MailServiceForm.getForm().findField('mail_subject').getValue();
	var port = SrvSetup.MailServiceForm.getForm().findField('mail_smtp_port').getValue();
	
	if( ip == '' || mailFrom == '' || mailTo == '' || subject == '' || port == '' ){
		
		CommonFunc.showMsgBox(Geo.Text.Common.message,LoadGetString('IDS_WARNING_LOST_SMTP_INFO'),Ext.MessageBox.WARNING);										
		return;
	}
	
	theApp.Content.body.mask(Geo.Text.LoadMask.sending, 'x-mask-loading');
	
	SrvSetup.MailServiceForm.getForm().submit(
	{
		url: 'ServerSetupData.php',
		method: 'POST',
		params: {requestType: 'TestMailAccount'},
		success: function(form, action) {
			
			theApp.Content.body.unmask();
			CommonFunc.showMsgBox(Geo.Text.Common.message,Geo.Text.Common.success);											
		},
		failure: function(form, action) {
			
			theApp.Content.body.unmask();
			SubmitFail(action,true,true);
		}
	});
}

MailSetup.showPanel =
function()
{
	MailSetup.MailService = {

		xtype: 'form',
		width: 650,
		labelWidth: 200,
		border:false, 
		autoHeight:true,
		//autoScroll:true,
		bodyStyle: 'padding: 10px',
		reader: new Ext.data.JsonReader({},		
			[		
				{name: 'mail_smtp', type: 'string'},
				{name: 'mail_from', type: 'string'},
				{name: 'mail_to', type: 'string'},
				{name: 'mail_subject', type: 'string'},
				{name: 'mail_text', type: 'string'},
				{name: 'mail_smtp_port', type: 'int'},
				{name: 'mail_smtp_ssl', type: 'int'},
				{name: 'mail_smtp_auth', type: 'int'},
				{name: 'mail_username', type: 'string'},
				//{name: 'mail_charset', type: 'string'},
				{name: 'mail_password', type: 'string'}								
			]
		),
		buttonAlign:'center',
		items:[	
			{
				xtype:'fieldset',
				title:'SMTP',
				labelWidth: 200,			
				defaultType: 'textfield',
				items:[
					{
						xtype: 'numberfield',
						fieldLabel:LoadGetString('IDS_PORT'),
						name: 'mail_smtp_port',
						allowBlank:false,
						allowNegative:false,
						minValue:1,
						maxValue:65535			
					},{
						xtype: 'combo',
						fieldLabel: LoadGetString('IDS_CONN_TYPE'),
						name: 'mail_smtp_ssl',
						hiddenName: 'mail_smtp_ssl',
						width: 200,					
						store: {
				
							xtype:'simplestore',
							fields:['value','text'],
							data:[
								[0,'None'],
								[1,'SSL'],
								[2,'TLS/STARTTLS']
							]
						},
						mode:'local',
						editable: false,
						valueField: 'value',
						displayField: 'text',
						triggerAction:'all',
						value:0,
						listeners: {
							'afterrender': function(p)
							{
								MailSetup.connectType = p;
							}
						}
					},{				
						xtype:'uxfieldset',
						fieldLabel:LoadGetString('IDS_AUTHENTICATION'),
						name: 'mail_smtp_auth',
						checkboxToggle:true,
						title:LoadGetString('IDS_ALLOW'),
						defaults: {width: 150},
						defaultType: 'textfield',
						collapsed: false,
						checkboxName:'mail_smtp_auth',					
						items:[					
							{
								fieldLabel:LoadGetString('IDS_USERNAME'),
								name: 'mail_username'							
							},{
								fieldLabel:LoadGetString('IDS_PASSWORD'),
								name: 'mail_password',
								inputType: 'password'
							}					
						]
					}
				
				]
			},{
				xtype:'fieldset',
				title:LoadGetString('IDS_MAIL_SETUP'),
				labelWidth: 200,			
				defaultType: 'textfield',
				items:[	
					{
						fieldLabel: LoadGetString('IDS_SMTP_SERVER'),
						width: 200,
						name: 'mail_smtp'
					},{
						fieldLabel: LoadGetString('IDS_EMAIL_FROM'),
						width: 200,
						name: 'mail_from',
						vtype: 'email'
					},{
						fieldLabel: LoadGetString('IDS_EMAIL_TO'),
						width: 200,
						name: 'mail_to'/*,
						vtype: 'email'*/
					}/*,{
						xtype: 'combo',
						fieldLabel: LoadGetString('IDS_CHARSET'),
						name: 'mail_charset',						
						width: 200,					
						store: new Ext.data.Store({
							proxy: new Ext.data.HttpProxy(
								new Ext.data.Connection({
									url: 'ServerSetupData.php',
									extraParams: {
										requestType: 'GetMailCharsetData'
									}
								})
							),
							reader: new Ext.data.ArrayReader({},
							[
								{name: 'text'}
							])	
						}),
						mode:'remote',
						editable: false,
						valueField: 'text',
						displayField: 'text',
						triggerAction:'all'				
					}*/,{
						fieldLabel: LoadGetString('IDS_SUBJECT'),
						width: 200,
						name:'mail_subject'
					},{
						xtype: 'panel',
						html: '<hr>'
					},{
						xtype:'fieldset',
						border: false,
						fieldLabel: LoadGetString('IDS_TEXT_CONTENT'),
						style:'padding:0px 0px 0px 0px',					
						items:[
							{					
								xtype: 'textarea',
								name: 'mail_text',
								hideLabel: true,
								width: 200,
								maxLength: 200
							},{
						
								xtype: 'button',							
								hideLabel: true,
								text: LoadGetString('IDS_TEST_MAIL_ACCOUNT'),
								handler: function()
								{
									MailSetup.testMail();									
								}
							}
						]
					}
					
				]
			}
		],
		listeners:{
			'afterrender': function(p)
			{
				SrvSetup.MailServiceForm = p;				
				MailSetup.loadData();
			}
		},
		buttons:[
			{
				text:LoadGetString('IDS_SAVE'),
				iconCls: 'x-icon-save',
				handler: function (){					
					MailSetup.saveData();
				}
			},{
				text:LoadGetString('IDS_RELOAD'),
				iconCls: 'x-icon-reload',
				handler:function(){					
					MailSetup.loadData();			
				}
			}
		]
	};
	
	MailSetup.panel = ({
		xtype: 'panel',
		id:'id_MailSetupPanel',
		frame: true,
		autoScroll: true,
		items:[
			MailSetup.MailService 
		]
		
	});
	
	theApp.Content.add(MailSetup.panel);
	theApp.Content.doLayout();			
}